<template>
  <div>
    <modal v-if="modal" title="" @close="changeModalState">
      <reason @close="changeModalState"/>
    </modal>
    <div class="wp-title wp-12">Причины</div>
    <nav-bar v-model="search" @action="changeModalState"/>
    <masonry class="wp-12"
      :columnClass="MasonryColumnClass"
      :cols="MasonryColumns"
      :gutter="MasonryGutter">
      <card v-for="(reason, index) in filteredReasons" :key="index"
        :title="reason.text" :menuItems="cardMenuItems"
        delete @delete="removeReason(reason)">
        <template v-slot:info>
          <div class="wp-layout">
            <div class="wp-12 wp-field">
              <div class="wp-field__title">
                Название
              </div>
              <div class="wp-field__content">
                <div class="wp-field__text">
                  {{ reason.text }}
                </div>
              </div>
            </div>
          </div>
        </template>
        <template v-slot:reason_grades>
          <card-table :optins="cardTableOptions" :index="cardTableIndex"
            :columnsDefs="cardTableColumnsDefs" :data="reason.reason_grades">
            <template v-slot:index="{ row }">
              {{ categoryByID[row.category] }}
            </template>
          </card-table>
        </template>
      </card>
    </masonry>
  </div>
</template>

<script>
import { mapState, mapActions, mapGetters } from 'vuex';

import { MasonryGutter, MasonryColumnClass, MasonryColumns } from '@/shared';

import Card from '@/components/Card.vue';
import CardTable from '@/components/card/CardTable.vue';
import NavBar from '@/components/NavBar.vue';

import Modal from '@/components/modal/Modal.vue';
import Reason from '@/components/modal/orgadmin/reasons/Reason.vue';

export default {
  name: 'IssuedGradeChanges',
  components: {
    NavBar,
    Card,
    CardTable,
    Modal,
    Reason,
  },
  data() {
    return {
      MasonryGutter,
      MasonryColumns,
      MasonryColumnClass,
      modal: false,
      search: '',
      cardMenuItems: [
        {
          text: 'Информация',
          prop: 'info',
        },
        {
          text: 'Изменения',
          prop: 'reason_grades',
        },
      ],
      cardTableOptions: {
        action: {
          icon: 'pen',
        },
      },
      cardTableIndex: {
        title: 'Категория',
        prop: 'category',
      },
      cardTableColumnsDefs: [{
        title: 'Изменение',
        prop: 'change',
      }],
    };
  },
  computed: {
    ...mapState('organization', ['reasons']),
    ...mapGetters('organization', ['categoryByID']),
    filteredReasons() {
      return this.reasons.filter(reason => reason.text.toLowerCase().indexOf(
        this.search.toLowerCase(),
      ) !== -1);
    },
  },
  methods: {
    ...mapActions('organization', [
      'getOrganizationReasons',
      'getOrganizationCategories',
      'deleteReason',
    ]),
    changeModalState(reason = null) {
      this.editedReason = reason;
      this.modal = !this.modal;
    },
    async removeReason(reason) {
      try {
        await this.deleteReason(reason.id);
        this.$toasted.success('Причина удалена');
      } catch (errors) {
        if (errors.length) {
          errors.forEach((err) => {
            this.$toasted.error(err.message);
          });
        } else {
          this.$toasted.error('Неизветсная ошибка');
        }
      }
    },
  },
  created() {
    this.getOrganizationCategories();
    this.getOrganizationReasons();
  },
};
</script>

<style lang="scss" scoped>
</style>
